<?php

class YResilience_Frontend {

	static $instance = false;

	public static function init() {
		if ( ! self::$instance ) {
			self::$instance = new YResilience_Frontend;
		}
		return self::$instance;
	}

	public function __construct() {
		$this->has_run = false;
		add_action( 'wp_footer' , array( $this, 'insert_init_js' ) );
	}

	public function insert_init_js() {
		if ( $this->has_run ) {
			return;
		}
		$this->has_run = true;

		$url = YResilience_Options::get_option( 'url' );
		$use_element_decoy = intval( YResilience_Options::get_option( 'use_element_decoy' ) );
		if ( 1 === $use_element_decoy ) {
			$use_element_decoy = 'true';
		} else {
			$use_element_decoy = 'false';
		}
		$use_resource_decoy = intval( YResilience_Options::get_option( 'use_resource_decoy' ) );
		if ( 1 === $use_resource_decoy ) {
			$use_resource_decoy = 'true';
		} else {
			$use_resource_decoy = 'false';
		}

		$resource_decoy_url = YResilience_Options::get_option( 'resource_decoy_url' );

		$element_decoy_id = YResilience_Options::get_option( 'element_decoy_id' );
		$element_decoy_class = YResilience_Options::get_option( 'element_decoy_class' );

		if ( intval( YResilience_Options::get_option( 'enabled' ) ) === 1 ) {
?>

<script>
if (oio == undefined) {
  var oio = {
	// the control image (refreshed from API from time to time)
	u: <?php echo wp_json_encode( $url ); ?>,
	
	// the url of the resource decoy
	at_ru: <?php echo wp_json_encode( $resource_decoy_url ); ?>,
	
	// element decoy attributes
	at_ei: <?php echo wp_json_encode( $element_decoy_id ); ?>,
	at_ec: <?php echo wp_json_encode( $element_decoy_class ); ?>,

	// whether to enable the element decoy adblock test
	at_e: <?php echo wp_json_encode( $use_element_decoy ); ?>,

	// whether to enable the resource decoy adblock test
	at_r: <?php echo wp_json_encode( $use_resource_decoy ); ?>,

	// variable for keeping track of we are initiated or not
	i: false,

	// variable for keeping track of how many control images we have loaded
	c: 0,

	// variable for saving the first control image data in (used on SPA units)
	uc: false,

	// variable to keep track of how many child:s of parent we have observed already
	cl: [],

	// variable to keep track of if a page view has been registered yet
	pv: false,

	// variable for holding a css style element
	css: false,

	d: document,
	
	start: function () {
	  return function() {
			
			if (oio.at_r === "true") {
				oio.at_r = true;
			} else {
				oio.at_r = false;
			}
			if (oio.at_e === "true") {
				oio.at_e = true;
			} else {
				oio.at_e = false;
			}

			/*!
			 * verge 1.10.2+201705300050
			 * http://npm.im/verge
			 * MIT Ryan Van Etten
			 * https://github.com/ryanve/verge/blob/1.10.2/verge.js
			 */
			!function(a,b,c){a[b]=c()}(oio,"v",function(){function a(){return{width:k(),height:l()}}function b(a,b){var c={};return b=+b||0,c.width=(c.right=a.right+b)-(c.left=a.left-b),c.height=(c.bottom=a.bottom+b)-(c.top=a.top-b),c}function c(a,c){return!(!(a=a&&!a.nodeType?a[0]:a)||1!==a.nodeType)&&b(a.getBoundingClientRect(),c)}function d(b){b=null==b?a():1===b.nodeType?c(b):b;var d=b.height,e=b.width;return d="function"==typeof d?d.call(b):d,(e="function"==typeof e?e.call(b):e)/d}var e={},f="undefined"!=typeof window&&window,g="undefined"!=typeof document&&document,h=g&&g.documentElement,i=f.matchMedia||f.msMatchMedia,j=i?function(a){return!!i.call(f,a).matches}:function(){return!1},k=e.viewportW=function(){var a=h.clientWidth,b=f.innerWidth;return a<b?b:a},l=e.viewportH=function(){var a=h.clientHeight,b=f.innerHeight;return a<b?b:a};return e.mq=j,e.matchMedia=i?function(){return i.apply(f,arguments)}:function(){return{}},e.viewport=a,e.scrollX=function(){return f.pageXOffset||h.scrollLeft},e.scrollY=function(){return f.pageYOffset||h.scrollTop},e.rectangle=c,e.aspect=d,e.inX=function(a,b){var d=c(a,b);return!!d&&d.right>=0&&d.left<=k()},e.inY=function(a,b){var d=c(a,b);return!!d&&d.bottom>=0&&d.top<=l()},e.inViewport=function(a,b){var d=c(a,b);return!!d&&d.bottom>=0&&d.right>=0&&d.top<=l()&&d.left<=k()},e});


			// enable secondary AB detection technique in certain cases
			if (navigator.userAgent.search(" Brave/") > -1) oio.at_r = true;
			
			if (oio.i) return false;
			oio.i = true;
			return oio.abd(function(){
				/**
				 * Load the first control image. If its a SPA type site, we will load
				 * many control images, but this is done via the observation facility.
				 */
				oio.now(oio.ur(oio.u), 'html');
				return true;
			});
	  }
	}(),

	/**
	 * Function for checking if an Adblocker is active in the user's browser.
	 * Uses three detection techniques in tandem:
	 * 1. Check if a known blocked URL was allowed to load.
	 * 2. Check if a known blocked HTML element becomes hidden.
	 * 3. Check if Ghostery / Peace is in use by looking for a forged _gaq object.
	 * @param {function} callback function, gets called if Adblock is detected, f
	 * @return {mixed} nothing, or what callback function returns
	 */
	abd: function () {
	  return function(f) {
			// cleanup routine
			function cu(rid) {
				if (oio.at_e) {
					var de = oio.d.getElementById(rid);
					de.parentNode.removeChild(de);
				}
			}

			if (oio.at_r) {
				// attempt to load a decoy resource
				var s = oio.d.createElement('script');
				s.type = 'text/javascript';
				s.async = true;
				s.src = oio.at_ru;
				setTimeout(function(){oio.d.getElementsByTagName('head')[0].appendChild(s);},100);
			}

			if (oio.at_e) {
				// define a few variables and timeouts used in check
				var rid=oio.at_ei, fg=oio.d.createDocumentFragment(), ft=oio.d.createElement('div');
				k1 = oio.d.createElement('div');
				k1.setAttribute('class', oio.at_ec);
				k1.setAttribute('id', rid);
				k1.style.cssText = 'position:absolute;display:block;';
				ft.append(k1);
				while (ft.firstChild) fg.appendChild(ft.firstChild);
				oio.d.body.insertBefore(fg, oio.d.body.childNodes[0]);
			}

			if (oio.at_e || oio.at_r) {
				var step=200, t1=800, t2=1000;
					(function eec(rid, tw) {
					// reset time if undefined (first run)
					if (tw == undefined) var tw = 0;

					// check if the decoy element gets eaten AND we have waited at least t1 milliseconds
					if (oio.at_e && oio.d.getElementById(rid).clientHeight == 0 && tw >= t1) {
						// remove decoy element
						cu(rid);
						// execute the payload since ADB was detected
						return f();
					}

					// check if we have waited more than t2 milliseconds
					if (tw >= t2) {
						// remove the decoy element
						cu(rid);

						// check if the decoy resource was blocked
						if (oio.at_r && typeof __hazzuu === 'undefined') {
							// execute the payload since ADB was detected
							return f();
						}

						// if we got here, it means Adblock was not detected. We don't do anything more.
						return;
					}
					// recurse until further notice
					setTimeout(function(){eec(rid,tw+step);},step);
				})(rid);
			}
	  }
	}(),

	/**
	 * Function for selecting a random word from arguments.
	 */
	rc: function () {
	  return function (a) {
		return a[Math.floor(Math.random() * a.length)];
	  }
	}(),

	/**
	 * Function for creating a string that looks like a common image name.
	 */
	rq: function () {
	  return function () {
		var sa = [];
		// word count
		var wc = Math.floor(Math.random() * 12 + 1);
		for (var i = 0; i < wc; i++) {
		  // character count of word
		  sa[i] = oio.rs([1, 13]);
		  sa[i] = sa[i].charAt(0).toUpperCase() + sa[i].substr(1);
		};
		return sa.join('-');
	  }
	}(),

	/**
	 * Simple function to retrieve a fairly random string.
	 */
	rs: function () {
	  return function (a) {
		var r = "", c = "abcdefghijklnopqrstuw0123456789";
		var l = 5, h = 12;
		if (a != undefined) {
		  if (a.length >= 1) {
			var l = parseInt(a[0]), h = parseInt(a[0]);
		  }
		  if (a.length >= 2) {
			var h = parseInt(a[1]);
		  }
		  if (a.length == 3) {
			c = a[2];
		  }
		}
		var le = Math.floor(Math.random() * (h - l + 1)) + l;
		for(i=0;i<le;i++) r += c.charAt(Math.floor(Math.random() * c.length));
		return r;
	  }
	}(),

	pad: function () {
	  return function (v, a) {
		v = String(v);
		if (a != undefined) {
		  l = parseInt(a[0]);
		  v = (new Array(l).join('0') + v).slice(-l);
		}
		return v;
	  }
	}(),

	/**
	 * URL variable insertion method.
	 * @param {string} URL u
	 * @param {v} associative array of variable keys and values v
	 * @return {string} resultant URL string
	 */
	ur: function () {
	  return function (u, v) {
		// find all variables and replace them (if implied or provided in v)
		var rx = /\[[a-zA-Z0-9:,-]+\]/g;
		var r = u.match(rx);

		if (r != null) {
		  for (var i=0;i<r.length;i++) {
			var n = r[i].replace('[', '').replace(']', '');
			var t = n.split(':');
			var key = t[0];
			var args = t[1];
			if (args != undefined) args = args.split(',');

			var value = r[i];
			if (key == 'r') var value = oio.rs(args);
			if (key == 'c') var value = oio.rc(args);
			if (key == 'q') var value = oio.rq();
			if (key == 'i') var value = oio.pad(v['i'], args);
			if (key == 'p') var value = oio.pad(v['p'], args);
			if (key == 'g') var value = oio.pad(v['g'], args);
			if (key == 'w') var value = oio.pad(v['w'], args);
			u = u.replace(r[i], value);
		  }
		}
		return u;
	  }
	}(),
	
	/**
	 * Method for observing an element in DOM, and binding a function to it.
	 */
	later: function () {
	  var MutationObserver = window.MutationObserver || window.WebKitMutationObserver,
		eventListenerSupported = window.addEventListener;

	  return function(o) {
			var obj = oio.d.querySelector(o.parent);
			if (obj == undefined) {
				return false;
			}
			if (MutationObserver) {
				// define a new observer
				var obs = new MutationObserver(function (mutations, observer) {
				if (mutations[0].addedNodes.length || mutations[0].removedNodes.length) {
					oio.scan(o);
				}
				});

				obs.observe(obj, {
					childList: true,
					subtree: true,
				});

				oio.scan(o);
			// fallback for IE9+
			} else if (eventListenerSupported) {
				obj.addEventListener('DOMNodeInserted', oio.scan, false);
			}
	  }
	}(),

	/*
	  This function scans the observe.parent element for instances of observe.child elements.
	  When it finds a new a child element, it loads units on it.
	  It uses a dictionary to keep track of what child elements it has already processed.
	  It is triggered by the observe() method.
	*/
	scan: function() {
	  return function(o) {
			var a = oio.d.querySelector(o.child).querySelector(o.parent);
			for (var p = 0; p < a.length; p++) {
				if (oio.cl[p] == undefined) {
				oio.cl[p] = a[p];
				oio.now(oio.ur(oio.u), a[p]);
				}
			}
	  }
	}(),

	/**
	 * Part of the system that reads in a PNG image and retrieves data encoded inside of it.
	 * @param {str} an image URL
	 * @param {function} a callback function to execute after data is retrieved
	 */
	now: function() {
	  return function (url, parent) {
		// if we have ucl cache, use that instead of downloading a new image
		if (oio.uc != false) {
		  oio.collection(oio.uc, parent);
		  oio.uc = false;
		  return;
		}

		var i = new Image();
		i.crossOrigin = "Anonymous";
		i.onload = function()
		{
		  oio.c++;
		  var c = oio.d.createElement("canvas");
		  var t = c.getContext("2d");
		  var w = i.width;
		  var h = i.height;
		  c.style.width = c.width = w;
		  c.style.height = c.height = h;
		  t.globalAlpha = 1.0;
		  t.globalCompositeOperation = 'copy';
		  t.drawImage(i, 0, 0);
		  var b = oio.p24(t.getImageData( 0, 0, w, h ).data);
		  var s = "";
		  for (var x=0; x<b.length; x++)
			if (b[x]) s += String.fromCharCode(b[x]);
		  var ucl = JSON.parse(s);
		  
		  // if its first run, and we should observe (SPA site)
		  if (oio.c == 1 && ucl.observe.enabled == 1) {
				// cache response since we want to register the first child before rendering units
				oio.uc = ucl;
				// set up the observation stuff
				oio.later(ucl.observe);
		  } else {
				// render units
				oio.collection(ucl, parent);
		  }
		};
		i.src = url;
	  }
	}(),

	/**
	 * The actual decoder for 24bit PNG images
	 * @param {Object} JS ImageData object
	 * @return {string} decoded string
	 */
	p24: function() {
	  return function(b) {
		var s = [];
		for (var i=0; i < b.length; i+=4) {
		  if (b[i+0] > 0) s.push(b[i+0]);
		  if (b[i+1] > 0) s.push(b[i+1]);
		  if (b[i+2] > 0) s.push(b[i+2]);
		}
		return s;
	  }
	}(),

	is_test: function () {
	  return function() {
		// __ytest is a url fragment we can set to put the units into a 'testing mode', useful when setting up
		if (window.location.hash.search("__ytest") > -1) test = true; else test = false;
		return test;
	  }
	}(),

	/**
	 * Method for adding a CSS style tag and returning a reference for it.
	 * @param {string} Initial style to set
	 * @return {node} style node
	*/
	acss: function() {
	  return function(css) {
		var h = oio.d.getElementsByTagName('head')[0], s = oio.d.createElement('style');
		s.setAttribute("type", "text/css");
		if (s.styleSheet) s.styleSheet.cssText = css;
		else s.appendChild(oio.d.createTextNode(css));
		return h.appendChild(s);
	  }
	}(),

	/**
	 * Method for finding the resolution id.
	*/
	g: function() {
	  return function() {
		var w = window.innerWidth;
		var r = 5;
		if (w <= 479) r = 1;
		if (w <= 767) r = 2;
		if (w <= 1023) r = 3;
		if (w <= 1439) r = 4;
		return r;
	  }
	}(),

	/**
	 * Method for managing a collection of units.
	*/
	collection: function () {
	  return function(ucl, parent) {
		var o = {
		  init: function () {
			if (oio.css == false) {
			  oio.css = oio.acss(ucl.css_common);
			}
			for (var i = 0; i < ucl.unit_list.length; i++) {
			  o.unit(ucl.unit_list[i], parent);
			}
		  },

		  unit: function (u, parent) {
				// check if we should avoid loading on this particular URL
				for (i=0;i<u.exclude_url_list.length;i++) {
					var eu = new RegExp(u.exclude_url_list[i]);
					if (window.location.pathname.match(eu)) return;
				}

				// determine which targeting variables to use
				if (u.target_selector != undefined && u.target_selector != "") {
					var ts = u.target_selector, ta = u.target_approach, cs = u.container_style;
				} else if (oio.is_test() && u.target_selector_test != undefined && u.target_selector_test != "") {
					var ts = u.target_selector_test, ta = u.target_approach_test, cs = u.container_style_test;
				} else return;

				u.css_specific += "."+u.widget_class + " {" + u.container_style + "}";

				// use qwery to get an element object list matching the specified target
				var t = oio.d.querySelector(parent).querySelector(ts);
				if (t === null) return;

				// append unit specific css
				oio.css.textContent += u.css_specific;

				// inject our unit into the HTML, based on the target_approach variable
				if (ta == "before") {
					var n = oio.d.createElement("div");
					n.innerHTML = u.html;
					t.parentNode.insertBefore(n, t);
					n.outerHTML = n.innerHTML;
				} else if (ta == "after") {
					var n = oio.d.createElement("div");
					n.innerHTML = u.html;
					t.parentNode.insertBefore(n, t.nextSibling);
					n.outerHTML = n.innerHTML;
				}
				else if (ta == "append") t.innerHTML = t.innerHTML + u.html;
				else if (ta == "prepend") t.innerHTML = u.html + t.innerHTML;
				else if (ta == "fill") t.innerHTML = u.html;

				u.unit = oio.d.querySelector("."+u.widget_class);

				// do the post init stuff (must wait for the units to be displayed)
				(function wait(tw){
					// break out either when we're successful or if we run out of attempts (should never happen)
					if (tw==undefined) var tw=0;
					else if (tw > 10) return;
					if (tw > 0 && o.rig(u) == true) return;
					// recurse until further notice
					setTimeout(function(){wait(tw+1);},100);
				})();

				window.addEventListener("resize", function() {
					o.rig(u);
				});
		  },

		  rig: function(u) {
				// select all images in the unit
				var e = oio.d.querySelectorAll("."+u.widget_class+" ."+u.img_class);
				// only agree to continue if we have a width on the first image (can be seen)
				if (e.clientWidth === 0) return false;

				// below code performs calculations necessary to properly set up the sprite image in each unit
				var ratio = e[0].clientWidth / ucl.sprite_width;
				var new_bg_height = Math.floor(ratio * ucl.sprite_height);
				var ad_height = Math.floor(new_bg_height / ucl.sprite_count);
				if (ad_height * ucl.sprite_count != new_bg_height) {
					new_bg_height = ad_height * ucl.sprite_count;
				}

				if (u.once == undefined) {
					u.once = true;
					// loop over all ads in the unit
					u.alv = [];
					for (var i=0;i<e.length;i++) {
						var ad_id = e[i].className.split(u.img_class+"_")[1];

						// append css for the sprite image
						oio.css.textContent += '.'+u.widget_class+' .'+u.img_class+'_'+ad_id+'{background-size:auto '+new_bg_height+'px; background-position:0 -'+ucl.ad_to_sprite[ad_id]*ad_height+'px;}';

						if (e[i].offsetParent !== null) {
							u.alv.push(ad_id);
						}

						// rig JS click events to redirect links to their proper locations
						var d = oio.d.querySelectorAll("#"+e[i].parentElement.parentElement.parentElement.id + " " + e[i].parentElement.tagName);
						for (p=0; p < d.length; p++) {
							if (d[p].onclick == null) {
								d[p].onclick = function(ee) {
									var a = ee.target || ee.srcElement;
									var ci = a.parentElement.getAttribute("ci");
									window.open(ucl.link_redirect_url + ucl.ad_to_link[ci], '_blank');
									return false;
								};
							}
						}
					}

					(function rview(){
						if (oio.v.inViewport(u.unit)) {
							/* note that after we fire our view-detection pixel once,
							* we return without setting another timer, which means
							* after the view is detected, all view-detection for that
							* unit ends.
							*/

							// lt will be populated with a string holding several IDs.
							var lt = "";
							lt = u.widget_id + "c" + u.alv.join([separator = "c"]);

							var pv = 0;
							if (oio.pv == false) {
							oio.pv = true;
							pv = 1;
							}

							// string replace in the widget_id and ad_listm and a random string to ensure no cache
							var i = new Image();
							i.src = oio.ur(ucl.view_url, {'i': lt, 'p': pv, 'g': oio.g(), 'w': u.widget_id});
							return;
						}
						// recurse until the view is triggered
						setTimeout(function(){rview();},1000);
					})();
				}
				return true;
		  },

		  rload: function() {
			var ls = "";
			for (var i=0; i < ucl.unit_list.length; i++) {
			  if (ucl.unit_list[i]["alv"] != undefined) {
				ls += ucl.unit_list[i]["widget_id"] + "c" + ucl.unit_list[i]["alv"].join([separator = "c"]) + "-";
			  }
			}
			ls = ls.substr(0, ls.length-1);
			var lsi = new Image();
			lsi.src = oio.ur(ucl.load_url, {'i': ls, 'g': oio.g()});
			return true;
		  },
		};

		o.init();
		setTimeout(o.rload, 1000);
		return o;
	  }
	}()
  };
}
oio.start();
</script>

<?php
		}
	}
}
